using System.Text.Json;
using System.Text.Json.Serialization;

namespace View_by_Distance.Shared.Models;

public class FaceDistance : Properties.IFaceDistance
{

    protected readonly List<double> _Distances;
    protected readonly bool? _IsWrongYear;
    protected readonly string _Key;
    protected readonly Mapping _Mapping;
    protected readonly DateTime _MinimumDateTime;
    public List<double> Distances => _Distances;
    public bool? IsWrongYear => _IsWrongYear;
    public string Key => _Key;
    public Mapping Mapping => _Mapping;
    public DateTime MinimumDateTime => _MinimumDateTime;

    [JsonConstructor]
    public FaceDistance(List<double> distances, bool? isWrongYear, string key, Mapping mapping, DateTime minimumDateTime)
    {
        _Distances = distances;
        _IsWrongYear = isWrongYear;
        _Key = key;
        _Mapping = mapping;
        _MinimumDateTime = minimumDateTime;
    }

    public override string ToString()
    {
        string result = JsonSerializer.Serialize(this, new JsonSerializerOptions() { WriteIndented = true });
        return result;
    }

}