namespace View_by_Distance.Shared.Models.Stateless.Methods;

public interface IProperty
{ // ...

    string TestStatic_DateTimeFormat();
    static string DateTimeFormat() => "yyyy:MM:dd HH:mm:ss";

    int TestStatic_GetDeterministicHashCode(byte[] value);
    static int GetDeterministicHashCode(byte[] value) =>
        Property.GetDeterministicHashCode(value);

    int TestStatic_GetDeterministicHashCode(string value);
    static int GetDeterministicHashCode(string value) =>
        Property.GetDeterministicHashCode(value);

    DateTime TestStatic_GetDateTime(Models.Property? property);
    static DateTime GetDateTime(Models.Property? property) =>
        Property.GetDateTime(property);

    DateTime TestStatic_GetMinimumDateTime(Models.Property? property);
    static DateTime GetMinimumDateTime(Models.Property? property) =>
        Property.GetMinimumDateTime(property);

    (int Season, string seasonName) TestStatic_GetSeason(int dayOfYear);
    static (int Season, string seasonName) GetSeason(int dayOfYear) =>
        Property.GetSeason(dayOfYear);

    string TestStatic_GetDiffRootDirectory(string diffPropertyDirectory);
    static string GetDiffRootDirectory(string diffPropertyDirectory) =>
        Property.GetDiffRootDirectory(diffPropertyDirectory);

    bool TestStatic_Any(Models.Container[] propertyHolderCollections);
    static bool Any(Models.Container[] propertyHolderCollections) =>
        Property.Any(propertyHolderCollections);

    (bool?, string[]) TestStatic_IsWrongYear(string[] segments, string year);
    static (bool?, string[]) IsWrongYear(string[] segments, string year) =>
        Property.IsWrongYear(segments, year);

    (bool?, string[]) TestStatic_IsWrongYear(string fileName, DateTime minimumDateTime);
    static (bool?, string[]) IsWrongYear(string fileName, DateTime minimumDateTime) =>
        throw new NotImplementedException(); //Property.IsWrongYear(fileName, minimumDateTime);

    List<DateTime> TestStatic_GetDateTimes(Models.Property property);
    static List<DateTime> GetDateTimes(Models.Property property) =>
        Property.GetDateTimes(property.CreationTime, property.LastWriteTime, property.DateTime, property.DateTimeDigitized, property.DateTimeOriginal, property.GPSDateStamp);

    double TestStatic_GetStandardDeviation(IEnumerable<long> values, double average);
    static double GetStandardDeviation(IEnumerable<long> values, double average) =>
        Property.GetStandardDeviation(values, average);

    TimeSpan TestStatic_GetThreeStandardDeviationHigh(int minimum, Models.Container container);
    static TimeSpan GetThreeStandardDeviationHigh(int minimum, Models.Container container) =>
        Property.GetThreeStandardDeviationHigh(minimum, container);

    (int, List<DateTime>, List<Models.Item>) TestStatic_Get(Models.Container container, TimeSpan threeStandardDeviationHigh, int i);
    static (int, List<DateTime>, List<Models.Item>) Get(Models.Container container, TimeSpan threeStandardDeviationHigh, int i) =>
        Property.Get(container, threeStandardDeviationHigh, i);

    List<DateTime> TestStatic_GetDateTimes(DateTime creationTime, DateTime lastWriteTime, DateTime? dateTime, DateTime? dateTimeDigitized, DateTime? dateTimeOriginal, DateTime? gpsDateStamp);
    static List<DateTime> GetDateTimes(DateTime creationTime, DateTime lastWriteTime, DateTime? dateTime, DateTime? dateTimeDigitized, DateTime? dateTimeOriginal, DateTime? gpsDateStamp) =>
        Property.GetDateTimes(creationTime, lastWriteTime, dateTime, dateTimeDigitized, dateTimeOriginal, gpsDateStamp);

}